/*
	
	
	
	Author:         Gerrit Maus
	Date:         	2016-12-23
	Version:        1.0
	Changelog:      -
*/


#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "../settings.h"
#include "battery.h"


extern volatile uint8_t battery_low;
extern volatile uint8_t battery_running;
volatile uint8_t adcycles = 0;


void battery_init(){
/*
	Initialises ADC stuff.
*/
	
	/* AVCC as reference voltage */
	ADMUX |= (1 << REFS0);
	/* Internal bandgap (1.1 V) as ADC input */
	ADMUX |= (1 << MUX3) | (1 << MUX2) | (1 << MUX1);
	ADCSRA |= (1 << ADIE);
	/* Prescaler 128 */
	ADCSRA |= (1 << ADPS0) | (1 << ADPS1) | (1 << ADPS2);
	ADCSRA |= (1 << ADEN);
	sei();
}

void battery_start(){
	
	adcycles = 0;
	battery_running = 1;
	ADCSRA |= (1 << ADSC);
}


ISR(ADC_vect){

	
	int adc;
	
	++adcycles;
	
	if(adcycles == ADCYCLES){
	
		adc = ADCL | (ADCH << 8);
	
		if(adc >= BATTBOUNDTOP && battery_low < 126){
		
			++battery_low;
		}
		
		if(adc <= BATTBOUNDBOTTOM && battery_low > 0){
			
			--battery_low;
		}
		
		battery_running = 0;
	}
	else{
	
		ADCSRA |= (1 << ADSC);
	}		
}


